#pragma once

#include <vector>

#include "gui/View.hpp"

namespace mcpaint {

struct Artboard {
	Vector2 position;
	Vector2 size;
	RenderTexture2D canvas;
	float scale;
};

class Artboards : public gui::view {
	protected:
		std::vector<Artboard> artboards;
		float scale = 0.0f;
		Vector2 offset;
		size_t currentArtboard = 0;

		void initialScale();
	public:
		Artboards();
		Artboards(Artboard initialArtboard);

		virtual gui::view::Type type() const override {
			return gui::view::Type::ARTBOARDS;
		}

		void update(float deltaTime, const gui::view* const parent = nullptr) override;
		void render(float deltaTime) override;
};

}