#pragma once

#include <functional>

#include "../Event.hpp"
#include "Icon.hpp"
#include "View.hpp"

using namespace mcpaint::events;

namespace mcpaint::gui {

using ButtonCallback = std::function<void(Event)>;

class button : public view {
	protected:
		bool isIcon = false;
		Icon icon;
		std::string label_;
		ButtonCallback callback;
	public:
		button(std::string label = "", ButtonCallback callback = [](Event) {});
		button(Icon icon, ButtonCallback callback = [](Event) {});

		virtual void update(float deltaTime, const view* const parent = nullptr) override;
		virtual void render(float deltaTime) override;

		size_t contentWidth() const override;

		virtual Type type() const override {
			return Type::BUTTON;
		}
};

inline button* Button(std::string label = "", ButtonCallback callback = [](Event) {}) {
	return new button(std::move(label), std::move(callback));
}

inline button* Button(Icon icon, ButtonCallback callback = [](Event) {}) {
	return new button(icon, std::move(callback));
}

}