#include "HStack.hpp"

namespace mcpaint::gui {

void hstack::update(float deltaTime, const view* const parent) {
	//this->updateSelf(deltaTime, parent);
	this->updateChildren(deltaTime);

	float  offset        = this->spec_.padding;				
	float  fullWidth     = this->size_.x - this->spec_.padding * 2 - ((this->children.size() - 1) * this->spec_.gap);
	size_t fixedChildren = 0;

	for (const auto& child : this->children) {
		const Spec& spec = child->spec();

		if (spec.display == Display::INLINE) {
			fullWidth -= child->contentWidth();
			fixedChildren++;
		} else if (std::holds_alternative<int>(spec.size.first)) {
			fullWidth -= std::get<int>(spec.size.first);
			fixedChildren++;
		}
	}

	for (const auto& child : this->children) {
		const Spec& spec = child->spec();

		float width;
		
		switch(spec.display) {
			case Display::INLINE:
				width = child->contentWidth();
				break;
			default:
				width = std::holds_alternative<int>(spec.size.first) ? std::get<int>(spec.size.first) : fullWidth / (this->children.size() - fixedChildren);
				break;
		}
		
		float height = this->size_.y - this->spec_.padding * 2;

		child->size_ = {round(width), height};
		child->position({this->position_.x + offset, this->position_.y + this->spec_.padding});
		offset += width + this->spec_.gap;
	}

}

void hstack::render(float deltaTime) {
	view::render(deltaTime);
}

}