#pragma once

#include <raylib.h>

#include "FontManager.hpp"
#include "View.hpp"

namespace mcpaint::gui {

enum class Icon : wchar_t {
	REGULAR = 0xf245,
	MOVE    = 0xf256,
	BRUSH   = 0xf1fc,
};

constexpr static int Iconset[] = {
	0xf245, // REGULAR
	0xf256, // MOVE
	0xf1fc, // BRUSH
};

inline void DrawIcon(Icon icon, Vector2 position, size_t size, Color color = WHITE) {
	DrawTextCodepoint(FontManager::IconFont(), static_cast<wchar_t>(icon), position, size,  color);
}

inline void DrawIcon(Icon icon, int posX, int posY, size_t size, Color color = WHITE) {
	DrawIcon(icon, {static_cast<float>(posX), static_cast<float>(posY)}, size, color);
}

inline Vector2 MeasureIcon(Icon icon, size_t size) {
	(void) icon;
	return {static_cast<float>(size), static_cast<float>(size)};
}

}