#pragma once

#include "View.hpp"

namespace mcpaint::gui {

class spacer : public view {
	protected:
		size_t thickness;
	public:
		spacer() : view(), thickness(1) {
			this->spec_.display = Display::INLINE;
			this->spec_.size    = {1, 100.0f};
			this->spec_.padding = 5;
		}

		virtual void render(float deltaTime) override {
			bool horizontal = this->size_.x > this->size_.y;

			float middle  = round(this->position_.x + this->size_.x / 2);
			float padding = this->spec_.padding;

			if (horizontal)
				DrawLineEx({this->position_.x + padding, middle}, {this->position_.x + this->size_.x - padding, middle}, 1, Theme::ELEMENT_BORDER);
			 else
				DrawLineEx({middle, this->position_.y + padding}, {middle, this->position_.y + this->size_.y - padding}, 1, Theme::ELEMENT_BORDER);
		}

		virtual inline size_t contentWidth() const override {
			return this->spec_.padding * 2 + this->thickness;
		}

		virtual inline Type type() const override {
			return Type::SPACER;
		}
};

inline spacer* Spacer() {
	return new spacer();
}

}