#include "VStack.hpp"

namespace mcpaint::gui {

void vstack::update(float deltaTime, const view* const parent) {
	this->updateSelf(deltaTime, parent);

	float  offset        = this->spec_.padding;
	float  fullHeight    = this->size_.y - this->spec_.padding * 2;
	size_t fixedChildren = 0;

	for (const auto& child : this->children) {
		const Spec& spec = child->spec();

		if (std::holds_alternative<int>(spec.size.second)) {
			fullHeight -= std::get<int>(spec.size.second);
			fixedChildren++;
		}
	}

	for (const auto& child : this->children) {
		const Spec& spec = child->spec();

		float height = std::holds_alternative<int>(spec.size.second) ? std::get<int>(spec.size.second) : fullHeight / (this->children.size() - fixedChildren);
		int   width  = this->size_.x - this->spec_.padding * 2;

		child->size_ = {static_cast<float>(width), height};
		child->position({this->position_.x + this->spec_.padding, this->position_.y + offset});
		offset += height;
	}

	this->updateChildren(deltaTime);
}

void vstack::render(float deltaTime) {
	view::render(deltaTime);
}

}