#pragma once

#include <raylib.h>
#include <raymath.h>

namespace mcpaint {

inline Vector2 GetWindowSize() {
	return {static_cast<float>(GetScreenWidth()), static_cast<float>(GetScreenHeight())};
}

inline constexpr Color ColorFromHex(uint32_t color) {
	uint8_t r = (color >> 24) & 0xFF;
	uint8_t g = (color >> 16) & 0xFF;
	uint8_t b = (color >> 8) & 0xFF;
	uint8_t a = color & 0xFF;

	return { r, g, b, a };
}

inline const Vector2& operator -= (Vector2& lhs, float rhs) {
	lhs = Vector2SubtractValue(lhs, rhs);
	return lhs;
}

inline const Vector2& operator += (Vector2& lhs, float rhs) {
	lhs = Vector2AddValue(lhs, rhs);
	return lhs;
}

}